package com.ruoyi.job.service.impl;

import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import cn.hutool.json.JSONArray;
import cn.hutool.json.JSONObject;
import cn.hutool.json.JSONUtil;
import com.ruoyi.job.domain.Project;
import com.ruoyi.job.mapper.ProjectMapper;
import com.ruoyi.job.service.ProjectService;
import com.sefonsoft.cloud.govern.service.invoke.ServiceSdk;
import com.sefonsoft.cloud.govern.service.invoke.domain.DataQuery;
import com.sefonsoft.cloud.govern.service.invoke.domain.DataServiceRequestDTO;
import com.sefonsoft.cloud.govern.service.invoke.domain.ServiceRequestFieldDTO;
import com.sefonsoft.cloud.govern.service.invoke.domain.SortDTO;
import com.sefonsoft.cloud.govern.service.invoke.utils.Tools;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

@Service
@Slf4j
public class ProjectServiceImpl implements ProjectService {

    @Autowired
    ProjectMapper getinfomapper;

    private static String url = "https://2.19.247.137:18199/data-service/gateway/v2.0/data-service";
    private static String userId = "a_sunjiyuan05033655";
    private static String subServiceId = "1827987788174319616";
    private static String applicationId = "SYS001";
    private static String accessToken = "1827987788174319617";
    private static String nextToken = "";

    @Scheduled(cron = "0 0 1 * * ?")
    public void getData() throws Exception {
        DataServiceRequestDTO req = null;
        int size = 1000;
        int currentSize = 1;

        while (currentSize != 0) {
            if (Tools.isNull(nextToken)) {
                List<ServiceRequestFieldDTO> mustFields = new ArrayList();
                mustFields.add(new ServiceRequestFieldDTO("areaId", "c..", "eq", "1591285477854248961"));
                List<ServiceRequestFieldDTO> shouldFields = new ArrayList();
                DateTime date = DateUtil.date();
                DateTime today = DateUtil.beginOfDay(date);
                shouldFields.add(new ServiceRequestFieldDTO("create_date", "dt", "le", today));
                shouldFields.add(new ServiceRequestFieldDTO("delete_date", "dt", "le", today));
                shouldFields.add(new ServiceRequestFieldDTO("update_date", "dt", "le", today));
                DataQuery query = (new DataQuery.Builder()).must(mustFields).should(shouldFields).build();
                req = (new DataServiceRequestDTO.Builder()).size(size).includeColumns(true).dataQuery(query).sort(new SortDTO("id", "asc")).build();
            } else {
                req = (new DataServiceRequestDTO.Builder()).size(size).nextToken(nextToken).includeColumns(false).build();
            }

            String result = ServiceSdk.invoke(url, req, userId, subServiceId, applicationId, accessToken);
            log.info("响应数据：{}", result);
            JSONObject JsonData = JSONUtil.parseObj(JSONUtil.parseObj(result).get("data").toString());
            nextToken = JsonData.get("next_token").toString();
            currentSize = JsonData.getInt("currentSize");
            JSONArray jsonArray = JsonData.getJSONArray("list");

            for (int i = 0; i < jsonArray.size(); ++i) {
                JSONObject data = jsonArray.getJSONObject(i);
                Project domain = new Project();
                domain.setId(data.get("id").toString());
                domain.setCreateDate((Date) data.get("createDate"));
                domain.setCreater(data.get("creater").toString());
                domain.setUpdateDate((Date) data.get("updateDate"));
                domain.setUpdater(data.get("updater").toString());
                domain.setDeleteDate((Date) data.get("deleteDate"));
                domain.setDeleter(data.get("deleter").toString());
                domain.setRemark(data.get("remark").toString());
                domain.setSort((Integer) data.get("sort"));
                domain.setSts(data.get("sts").toString());
                domain.setAreaId(data.get("areaId").toString());
                domain.setCompanyName(data.get("companyName").toString());
                domain.setDescription(data.get("description").toString());
                domain.setGreat((Integer) data.get("great"));
                domain.setInvest((Integer) data.get("invest"));
                domain.setMapAddr(data.get("mapAddr").toString());
                domain.setMode(data.get("mode").toString());
                domain.setProjectAddr(data.get("projectAddr").toString());
                domain.setProjectName(data.get("projectName").toString());
                domain.setRecordCode(data.get("recordCode").toString());
                domain.setRecordDate((Date) data.get("recordDate"));
                domain.setStage(data.get("stage").toString());
                int num = getinfomapper.addInfo(domain);
                log.info("本次导入{}条数据", num);
            }
        }

    }
}
